Option Strict Off
Option Explicit On
Module API_Functions
	
	Const MOVEFILE_REPLACE_EXISTING As Short = &H1s
	Const FILE_ATTRIBUTE_TEMPORARY As Short = &H100s
	Const FILE_BEGIN As Short = 0
	Const FILE_SHARE_READ As Short = &H1s
	Const FILE_SHARE_WRITE As Short = &H2s
    Const CREATE_NEW As Short = 1
    Const CREATE_ALWAYS As Short = 2
    Const OPEN_EXISTING As Short = 3
    Const OPEN_ALLWAYS As Short = 4
    Const GENERIC_READ As Integer = &H80000000
    Const GENERIC_WRITE As Integer = &H40000000
	

    Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As UInteger, ByRef lpBuffer As Byte(), ByVal nNumberOfBytesToWrite As UInteger, ByRef lpNumberOfBytesWritten As UInteger, ByVal lpOverlapped As UInteger) As UInteger
    Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As UInteger, ByRef lpBuffer As Byte(), ByVal nNumberOfBytesToRead As UInteger, ByRef lpNumberOfBytesRead As UInteger, ByVal lpOverlapped As UInteger) As UInteger
    Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Integer, ByVal dwShareMode As UInteger, ByVal lpSecurityAttributes As UInteger, ByVal dwCreationDisposition As UInteger, ByVal dwFlagsAndAttributes As UInteger, ByVal hTemplateFile As UInteger) As UInteger
    Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As UInteger) As UInteger
    Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As UInteger, ByVal lDistanceToMove As UInteger, ByRef lpDistanceToMoveHigh As UInteger, ByVal dwMoveMethod As UInteger) As UInteger
    Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As UInteger, ByRef lpFileSizeHigh As UInteger) As UInteger
    Private Declare Function SetEndOfFile Lib "kernel32" (ByVal hFile As UInteger) As UInteger
	
    Public Sub API_OpenFile(ByVal FileName As String, ByRef FileNumber As UInteger, ByRef FileSize As ULong)
        Dim FileH As UInteger
        Dim Ret As UInteger
        On Error Resume Next
        FileH = CreateFile(FileName, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0, OPEN_ALLWAYS, 0, 0)
        If Err.Number > 0 Then
            Err.Clear()
            FileNumber = 0
        Else
            FileNumber = FileH
            Ret = SetFilePointer(FileH, 0, 0, FILE_BEGIN)
            API_FileSize(FileH, FileSize)
        End If
        On Error GoTo 0
    End Sub
    Public Sub API_FileSize(ByVal FileNumber As UInteger, ByRef FileSize As ULong)
        Dim FileSizeL As UInteger
        Dim FileSizeH As UInteger
        FileSizeH = 0
        FileSizeL = GetFileSize(FileNumber, FileSizeH)
        Long2Size(FileSizeL, FileSizeH, FileSize)
    End Sub
	
    Public Sub API_ReadFile(ByVal FileNumber As UInteger, ByVal Position As ULong, ByRef BlockSize As UInteger, ByRef Data() As Byte)
        Dim PosL As UInteger
        Dim PosH As UInteger
        Dim SizeRead As UInteger
        Dim Ret As UInteger
        Size2Long(Position, PosL, PosH)
        Ret = SetFilePointer(FileNumber, PosL, PosH, FILE_BEGIN)
        Ret = ReadFile(FileNumber, Data, BlockSize, SizeRead, 0)
        BlockSize = SizeRead
    End Sub
	
    Public Sub API_CloseFile(ByVal FileNumber As UInteger)
        Dim Ret As UInteger
        Ret = CloseHandle(FileNumber)
    End Sub
	
    Public Sub API_WriteFile(ByVal FileNumber As UInteger, ByVal Position As ULong, ByRef BlockSize As UInteger, ByRef Data() As Byte)
        Dim PosL As UInteger
        Dim PosH As UInteger
        Dim SizeWrit As UInteger
        Dim Ret As UInteger
        Size2Long(Position, PosL, PosH)
        Ret = SetFilePointer(FileNumber, PosL, PosH, FILE_BEGIN)
        Ret = WriteFile(FileNumber, Data, BlockSize, SizeWrit, 0)
        BlockSize = SizeWrit
    End Sub
	
    Private Sub Size2Long(ByVal FileSize As ULong, ByRef LongLow As UInteger, ByRef LongHigh As UInteger)
        LongHigh = (FileSize And &HFFFFFFFF00000000) / &H100000000
        LongLow = FileSize And &HFFFFFFFF
    End Sub
	
    Private Sub Long2Size(ByVal LongLow As UInteger, ByVal LongHigh As UInteger, ByRef FileSize As ULong)
        FileSize = (LongHigh * &H100000000) Or LongLow
    End Sub
End Module